#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <assert.h>
#include "el.h"

/*
   Լ  ڼ  Ͻô  Ʒ  Ͻʽÿ.

    1)     κп ϴ static RvMethodDef method[]
        ã ˰ ϴ ޽ ̸ Type  Ȯմϴ.

    2) http://envlang.kldp.net/refs/core_array.html  Ͽ
       ش method  type  ãϴ.

    3) Դϴ.
 */

/* 迭  üȭ  ŬԴϴ.  */

/**
   迭 ο  field    ִ ü.
 */
static RvFieldDef field[] = 
  {
    { "value",  "[" },
    { "len",    "I" },
    { "maxlen", "I" },
    { NULL, NULL },
  };

/** append (TX)V - 迭 ü SELF  ι° (X)    մϴ.  */
static int
array_append (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int n = RvArrayLength (self);

  if (n == INT_MAX)
    {
      RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "cannot add more objects to list");
      return -1;
    }

  if (RvArrayResize (self, n + 1))
    return -1;

  if (RvArraySetItem (self, n, args))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tis (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  int i, len;

  if (RvParseArg (self, args, "is#", &i, &str, &len))
    return -1;

  if (RvArrayInsert (self, i, "S", RvStrNew (self, str, len)))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tia (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  RvObject *array;

  if (RvParseArg (self, args, "i[", &i, &array))
    return -1;

  if (RvArrayInsert (self, i, "[", array))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tib (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  unsigned char value;

  if (RvParseArg (self, args, "ib", &i, &value))
    return -1;

  if (RvArrayInsert (self, i, "B", value))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tic (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  char value;

  if (RvParseArg (self, args, "ic", &i, &value))
    return -1;

  if (RvArrayInsert (self, i, "C", value))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tih (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  short value;

  if (RvParseArg (self, args, "ih", &i, &value))
    return -1;

  if (RvArrayInsert (self, i, "H", value))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tii (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  int value;

  if (RvParseArg (self, args, "ii", &i, &value))
    return -1;

  if (RvArrayInsert (self, i, "I", value))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tif (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  float value;

  if (RvParseArg (self, args, "if", &i, &value))
    return -1;

  if (RvArrayInsert (self, i, "F", value))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tid (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  double value;

  if (RvParseArg (self, args, "id", &i, &value))
    return -1;

  if (RvArrayInsert (self, i, "D", value))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_insert_tit (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  RvObject *value;

  if (RvParseArg (self, args, "it", &i, &value))
    return -1;

  if (RvArrayInsert (self, i, "T", value))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_reverse_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int len = RvArrayLength (self);

  if (len > 1)
    RvArrayReverse (self);

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_pop_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  RvValue *value;

  if (RvArrayPop (self, &value))
    return -1;

  RvSetReturnValue (ret, value);

  return 0;
}

static int
array_pop_ti (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  RvValue *value;

  if (RvParseArg (self, args, "i", &i))
    return -1;

  if (RvArrayPopWithIndex (self, i, &value))
    return -1;

  RvSetReturnValue (ret, value);

  return 0;
}

static int
array_count (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int count = 0;
  int i;
  RvValue *entry = RvArrayGetEntry (self);
  
  for (i = 0; i < RvArrayLength (self); i++)
    {
      int rv = RvValueRichCompare (RvValueEntryItem (entry, i), args);

      if (rv > 0)
        count++;
      else if (rv < 0)
        return -1;
    }

  RvSetReturn (self, ret, "I", count);
  return 0;
}

static int
array_remove (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i;
  RvValue *entry = RvArrayGetEntry (self);
  
  for (i = 0; i < RvArrayLength (self); i++)
    {
      int rv = RvValueRichCompare (RvValueEntryItem (entry, i), args);

      if (rv > 0)
        {
          if (RvArraySliceAdvanced (self, i, i + 1, NULL))
            return -1;

          RvSetReturn (self, ret, "V");
          return 0;
        }
      else if (rv < 0)
        return -1;
    }

  return -1;
}

static int
array_extend_ta (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  RvObject *b;

  b = RvValueArrayRef (args);
  if (!b)
    return -1;

  if (RvArrayExtend (self, b))
    return -1;

  RvSetReturn (self, ret, "V");

  return 0;
}

static int
array_index_tx (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i, start=0, stop = RvArrayLength (self);
  RvValue *v, *entry = RvArrayGetEntry (self);

  if (RvParseArg (self, args, "x", &v))
    return -1;

  if (start < 0)
    {
      start += RvArrayLength (self);
      if (start < 0)
        start = 0;
    }

  if (stop < 0) 
    {
      stop += RvArrayLength (self);
      if (stop < 0)
        stop = 0;
    }

  for (i = start; i < stop && i < RvArrayLength (self); i++) 
    {
      int cmp = RvValueRichCompare (RvValueEntryItem (entry, i), v);
      if (cmp > 0)
        {
          RvSetReturn (self, ret, "I", i);
          return 0;
        }
      else if (cmp < 0)
        return -1;
    }

  RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "list.index(x): x not in list");
  return -1;
}

static int
array_index_txi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i, start=0, stop = RvArrayLength (self);
  RvValue *v, *entry = RvArrayGetEntry (self);

  if (RvParseArg (self, args, "xi", &v, &start))
    return -1;

  if (start < 0)
    {
      start += RvArrayLength (self);
      if (start < 0)
        start = 0;
    }

  if (stop < 0) 
    {
      stop += RvArrayLength (self);
      if (stop < 0)
        stop = 0;
    }

  for (i = start; i < stop && i < RvArrayLength (self); i++)
    {
      int cmp = RvValueRichCompare (RvValueEntryItem (entry, i), v);
      if (cmp > 0)
        {
          RvSetReturn (self, ret, "I", i);
          return 0;
        }
      else if (cmp < 0)
        return -1;
    }

  RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "list.index(x): x not in list");
  return -1;
}

static int
array_index_txii (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int i, start=0, stop = RvArrayLength (self);
  RvValue *v, *entry = RvArrayGetEntry (self);

  if (RvParseArg (self, args, "xii", &v, &start, &stop))
    return -1;

  if (start < 0)
    {
      start += RvArrayLength (self);
      if (start < 0)
        start = 0;
    }

  if (stop < 0)
    {
      stop += RvArrayLength (self);
      if (stop < 0)
        stop = 0;
    }

  for (i = start; i < stop && i < RvArrayLength (self); i++)
    {
      int cmp = RvValueRichCompare (RvValueEntryItem (entry, i), v);
      if (cmp > 0)
        {
          RvSetReturn (self, ret, "I", i);
          return 0;
        }
      else if (cmp < 0)
        return -1;
    }

  RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "list.index(x): x not in list");
  return -1;
}

/**
   L.sort (cmp=None, key=None, reverse=False)
*/
static RvMethodDef method[] =
  {
    { "append",         "(T[)V",        array_append },
    { "append",         "(TB)V",        array_append },
    { "append",         "(TC)V",        array_append },
    { "append",         "(TH)V",        array_append },
    { "append",         "(TI)V",        array_append },
    { "append",         "(TF)V",        array_append },
    { "append",         "(TD)V",        array_append },
    { "append",         "(TT)V",        array_append },
    { "append",         "(TS)V",        array_append },
    { "count",          "(T[)I",        array_count },
    { "count",          "(TB)I",        array_count },
    { "count",          "(TC)I",        array_count },
    { "count",          "(TH)I",        array_count },
    { "count",          "(TI)I",        array_count },
    { "count",          "(TF)I",        array_count },
    { "count",          "(TD)I",        array_count },
    { "count",          "(TT)I",        array_count },
    { "count",          "(TS)I",        array_count },
    { "extend",         "(T[)V",        array_extend_ta },
    { "index",          "(T[)I",        array_index_tx },
    { "index",          "(TB)I",        array_index_tx },
    { "index",          "(TC)I",        array_index_tx },
    { "index",          "(TH)I",        array_index_tx },
    { "index",          "(TI)I",        array_index_tx },
    { "index",          "(TF)I",        array_index_tx },
    { "index",          "(TD)I",        array_index_tx },
    { "index",          "(TT)I",        array_index_tx },
    { "index",          "(TS)I",        array_index_tx },
    { "index",          "(T[I)I",       array_index_txi },
    { "index",          "(TBI)I",       array_index_txi },
    { "index",          "(TCI)I",       array_index_txi },
    { "index",          "(THI)I",       array_index_txi },
    { "index",          "(TII)I",       array_index_txi },
    { "index",          "(TFI)I",       array_index_txi },
    { "index",          "(TDI)I",       array_index_txi },
    { "index",          "(TTI)I",       array_index_txi },
    { "index",          "(TSI)I",       array_index_txi },
    { "index",          "(T[II)I",      array_index_txii },
    { "index",          "(TBII)I",      array_index_txii },
    { "index",          "(TCII)I",      array_index_txii },
    { "index",          "(THII)I",      array_index_txii },
    { "index",          "(TIII)I",      array_index_txii },
    { "index",          "(TFII)I",      array_index_txii },
    { "index",          "(TDII)I",      array_index_txii },
    { "index",          "(TTII)I",      array_index_txii },
    { "index",          "(TSII)I",      array_index_txii },
    { "insert",         "(TI[)V",       array_insert_tia },
    { "insert",         "(TIB)V",       array_insert_tib },
    { "insert",         "(TIC)V",       array_insert_tic },
    { "insert",         "(TIH)V",       array_insert_tih },
    { "insert",         "(TII)V",       array_insert_tii },
    { "insert",         "(TIF)V",       array_insert_tif },
    { "insert",         "(TID)V",       array_insert_tid },
    { "insert",         "(TIT)V",       array_insert_tit },
    { "insert",         "(TIS)V",       array_insert_tis },
    { "pop",            "(T)[",         array_pop_t },
    { "pop",            "(T)B",         array_pop_t },
    { "pop",            "(T)C",         array_pop_t },
    { "pop",            "(T)H",         array_pop_t },
    { "pop",            "(T)I",         array_pop_t },
    { "pop",            "(T)F",         array_pop_t },
    { "pop",            "(T)D",         array_pop_t },
    { "pop",            "(T)T",         array_pop_t },
    { "pop",            "(T)S",         array_pop_t },
    { "pop",            "(TI)[",        array_pop_ti },
    { "pop",            "(TI)B",        array_pop_ti },
    { "pop",            "(TI)C",        array_pop_ti },
    { "pop",            "(TI)H",        array_pop_ti },
    { "pop",            "(TI)I",        array_pop_ti },
    { "pop",            "(TI)F",        array_pop_ti },
    { "pop",            "(TI)D",        array_pop_ti },
    { "pop",            "(TI)T",        array_pop_ti },
    { "pop",            "(TI)S",        array_pop_ti },
    { "remove",         "(T[)V",        array_remove },
    { "remove",         "(TB)V",        array_remove },
    { "remove",         "(TC)V",        array_remove },
    { "remove",         "(TH)V",        array_remove },
    { "remove",         "(TI)V",        array_remove },
    { "remove",         "(TF)V",        array_remove },
    { "remove",         "(TD)V",        array_remove },
    { "remove",         "(TT)V",        array_remove },
    { "remove",         "(TS)V",        array_remove },
    { "reverse",        "(T)V",         array_reverse_t },
    { NULL, },
  };

/** entry point.  */
int
init_array (RvClass *cls)
{
  if (RvDefineFields (cls, field))
    return -1;

  if (RvDefineMethods (cls, method))
    return -1;

  return 0;
}
