#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <limits.h>
#include <assert.h>
#include "el.h"

#define ROVM
#include "regex.h"

/*
  ROVM Server  ϴ Class   ڿ ü Ű ŬԴϴ.
  Core Ŭ  ϳν, ڿ VM  ߿  ,  Ŭ 
  ü ڵ ȯǰ ˴ϴ.   StringRef  ٷ  Ŭ ObjectRef
   Դϴ.
  
  !!!!
  StringRef  value ʵ ſ Ưϰ Ǿ ϴ κԴϴ.  
   value ʵ , Type  `['  ArrayRef   , 
  ޸   ش ArrayRef  ƴմϴ.  ̷  Ű 
  value   RvValue ü STACK_IS_STRINGVALUE (NODE)  1  
  Ǿ ֽϴ.
 */

/* need to include <ctype.h> to use these macros */
#ifndef ISPRINT
#define ISASCII(c) isascii((int)(unsigned char)(c))
#undef ISPRINT
#define ISPRINT(c) (ISASCII(c) && isprint((int)(unsigned char)(c)))
#define ISSPACE(c) (ISASCII(c) && isspace((int)(unsigned char)(c)))
#define ISUPPER(c) (ISASCII(c) && isupper((int)(unsigned char)(c)))
#define ISLOWER(c) (ISASCII(c) && islower((int)(unsigned char)(c)))
#define ISALNUM(c) (ISASCII(c) && isalnum((int)(unsigned char)(c)))
#define ISALPHA(c) (ISASCII(c) && isalpha((int)(unsigned char)(c)))
#define ISDIGIT(c) (ISASCII(c) && isdigit((int)(unsigned char)(c)))
#define ISXDIGIT(c) (ISASCII(c) && isxdigit((int)(unsigned char)(c)))
#endif

static RvFieldDef field[] = 
  {
    /* !!!!
       StringRef  value ʵ ſ Ưϰ Ǿ ϴ κԴϴ.  
        value ʵ , Type  `['  ArrayRef   , 
       ޸   ش ArrayRef  ƴմϴ.  ̷  Ű 
       value   RvValue ü STACK_IS_STRINGVALUE (NODE)  1  
       Ǿ ֽϴ.  */
    { "value",  "[" },
    { "len",    "I" },
    { NULL, NULL },
  };

/**
  ʱȭ ޽ : __init__ (TSI)V

  ڿ S   I  о鿩, Field  value  len  մϴ.
*/
static int
str_init_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  int len;

  if (RvParseArg (self, args, "si", &str, &len))
    return -1;

  /* .  */
  
  return 0;
}

/*
  Ʒ split ޽ 3  , ϳ  Լ   ִ Դϴٸ
    ؼ    ·  ִ Դϴ.

  ̸  ں ʴϴ! (2006-02-19)
 */

/**
  Split ޽ : split (T)[

  SELF  StringRef  Ͽ, ڿ ISPACE   split Ͽ
  ׿  迭 ȯմϴ.
  
  @return       ڿ ISPACE  split   迭Դϴ.
*/
static int
str_split_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int len, skip = 1, limit = 0, lim = 0;
  char *str, *ptr, *eptr;
  long beg, end, i = 0;
  RvObject *result, *tmp;

  /* StringRef  ArrayRef  value  Ưϰ   Ѵ.  */
  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &len))
    return -1;

  ptr = str;

  result = RvArrayNew (self, 0);
  eptr = ptr + len;

  for (end = beg = 0; ptr<eptr; ptr++)
    {
      if (skip) 
        {
          if (ISSPACE (*ptr))
            beg++;
          else 
            {
              end = beg + 1;
              skip = 0;
              if (!(limit == 0) && lim <= i) 
                break;
            }
        }
      else 
        {
          if (ISSPACE (*ptr)) 
            {
              RvArrayPush (result, "S", RvStrSubstr (self, str, beg, end - beg));
              skip = 1;
              beg = end + 1;
              if (!(limit == 0)) 
                ++i;
            }
          else
            end++;
        }
    }

  if (len > 0 && (!(limit == 0) || len > beg || lim < 0)) 
    {
      if (len == beg)
        {
          RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "Can't handle this situation.");
          return -1;
        }
      else
        tmp = RvStrSubstr (self, str, beg, len - beg);
      RvArrayPush (result, "S", tmp);
    }

  if ((limit == 0) && lim == 0)
    {
      while (RvArrayLength (result) > 0)
        {
          RvValue *last;

          last = RvArrayLastValue (result);
          if (!last)
            break;

          if (RvGetField (RvValueStringRef (last), "len", "I", &len))
            return -1;

          if (len > 0)
            break;

          RvArrayPop (result, NULL);
        }
    }

  RvSetReturn (self, ret, "[", result);

  return 0;
}

/**
  Split ޽ : split (TS)[

  SELF  StringRef  Ͽ, ڿ ι° argument   split Ͽ
  ׿  迭 ȯմϴ.
  
  @return       ڿ ι°  (StringRef)  split   迭Դϴ.
*/
static int
str_split_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int limit = 0, lim = 0;
  long i = 0;
  char *str, *pat, *error;
  int strlen, patlen;
  long beg;
  regex_t *re;
  int last_null;
  long idx;
  long start = 0, end;
  struct re_registers re_regs, *regs = NULL;
  RvObject *result, *tmp;

#define BEG(no) regs->beg[no]
#define END(no) regs->end[no]

  if (RvParseArg (self, args, "s#", &pat, &patlen))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  re = (regex_t *) calloc (1, sizeof (regex_t));
  memset (&re_regs, '\0', sizeof (struct re_registers));
  error = re_compile_pattern (pat, patlen, re);
  if (error)
    {
      RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "%s", error);
      return -1;
    }

  result = RvArrayNew (self, 0);

  beg = 0;
  last_null = beg;
  while ((end = re_search (re, str, strlen, start, strlen - start, &re_regs)) >= 0)
    {
      regs = &re_regs;
      if (start == end && BEG (0) == END (0)) 
        {
          if (!str)
            {
              RvArrayPush (result, "S", RvStrNew (self, "", 0));
              break;
            }
          else if (last_null == 1) 
            {
              RvArrayPush (result, "S", RvStrSubstr (self, str, beg, mbclen (str[beg])));
              beg = start;
            }
          else 
            {
              start += mbclen (str[start]);
              last_null = 1;
              continue;
            }
        }
      else 
        {
          RvArrayPush (result, "S", RvStrSubstr (self, str, beg, end - beg));
          beg = start = END (0);
        }
      last_null = 0;
      
      for (idx=1; idx < regs->num_regs; idx++)
        {
          if (BEG (idx) == -1)
            continue;
          if (BEG (idx) == END (idx))
            {
              RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "TODO");
              return -1;
            }
          else
            tmp = RvStrSubstr (self, str, BEG (idx), END (idx) - BEG (idx));
          
          RvArrayPush (result, "S", tmp);
        }
      if (!(limit == 0) && lim <= ++i) break;
    }
  
  if (strlen > 0 && (!(limit == 0) || strlen > beg || lim < 0)) 
    {
      if (strlen == beg)
        {
          RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "Can't handle this situation.");
          return -1;
        }
      else
        tmp = RvStrSubstr (self, str, beg, strlen - beg);
      RvArrayPush (result, "S", tmp);
    }

  if ((limit == 0) && lim == 0)
    {
      while (RvArrayLength (result) > 0)
        {
          int len;
          RvValue *last;

          last = RvArrayLastValue (result);
          if (!last)
            break;

          if (RvGetField (RvValueStringRef (last), "len", "I", &len))
            return -1;

          if (len > 0)
            break;

          RvArrayPop (result, NULL);
        }
    }
  
  RvSetReturn (self, ret, "[", result);
  
  if (regs)
    re_free_registers (regs);
  re_free_pattern (re);

  return 0;
}

/**
  Split ޽ : split (TSI)[

  SELF  StringRef  Ͽ, ڿ ι° argument   split Ͽ
  ׿  迭 ȯմϴ.  , max limit   ֽϴ.
  
  @return       ڿ ι°  (StringRef)  split   迭Դϴ.
*/
static int
str_split_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int limit = 1, lim = 0;
  long i = 0;
  char *str, *pat, *error;
  int strlen, patlen;
  long beg;
  regex_t *re;
  int last_null;
  long idx;
  long start = 0, end;
  struct re_registers re_regs, *regs = NULL;
  RvObject *result, *tmp;

#define BEG(no) regs->beg[no]
#define END(no) regs->end[no]

  if (RvParseArg (self, args, "s#i", &pat, &patlen, &lim))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  if (lim <= 0)
    limit = 0;
  else if (lim == 1)
    {
      if (strlen == 0)
        {
          RvSetReturn (self, ret, "[", RvArrayNew (self, 0));
          return 0;
        }
      result = RvArrayNew (self, 0);
      RvArrayPush (result, "S", RvStrSubstr (self, str, 0, strlen));
      RvSetReturn (self, ret, "[", result);
      return 0;
    }
  i = 1;

  re = (regex_t *) calloc (1, sizeof (regex_t));
  memset (&re_regs, '\0', sizeof (struct re_registers));
  error = re_compile_pattern (pat, patlen, re);
  if (error)
    {
      RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "%s", error);
      return -1;
    }

  result = RvArrayNew (self, 0);

  beg = 0;
  last_null = beg;
  while ((end = re_search (re, str, strlen, start, strlen - start, &re_regs)) >= 0)
    {
      regs = &re_regs;
      if (start == end && BEG (0) == END (0)) 
        {
          if (!str)
            {
              RvArrayPush (result, "S", RvStrNew (self, "", 0));
              break;
            }
          else if (last_null == 1) 
            {
              RvArrayPush (result, "S", RvStrSubstr (self, str, beg, mbclen (str[beg])));
              beg = start;
            }
          else 
            {
              start += mbclen (str[start]);
              last_null = 1;
              continue;
            }
        }
      else 
        {
          RvArrayPush (result, "S", RvStrSubstr (self, str, beg, end - beg));
          beg = start = END (0);
        }
      last_null = 0;
      
      for (idx=1; idx < regs->num_regs; idx++)
        {
          if (BEG (idx) == -1)
            continue;
          if (BEG (idx) == END (idx))
            {
              RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "TODO");
              return -1;
            }
          else
            tmp = RvStrSubstr (self, str, BEG (idx), END (idx) - BEG (idx));
          
          RvArrayPush (result, "S", tmp);
        }
      if (!(limit == 0) && lim <= ++i) break;
    }
  
  if (strlen > 0 && (!(limit == 0) || strlen > beg || lim < 0)) 
    {
      if (strlen == beg)
        {
          RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "Can't handle this situation.");
          return -1;
        }
      else
        tmp = RvStrSubstr (self, str, beg, strlen - beg);
      RvArrayPush (result, "S", tmp);
    }

  if ((limit == 0) && lim == 0)
    {
      while (RvArrayLength (result) > 0)
        {
          int len;
          RvValue *last;

          last = RvArrayLastValue (result);
          if (!last)
            break;

          if (RvGetField (RvValueStringRef (last), "len", "I", &len))
            return -1;

          if (len > 0)
            break;

          RvArrayPop (result, NULL);
        }
    }
  
  RvSetReturn (self, ret, "[", result);
  
  if (regs)
    re_free_registers (regs);
  re_free_pattern (re);

  return 0;
}

static void
string_adjust_indices (int *start, int *end, int len)
{
  if (*end > len)
    *end = len;
  else if (*end < 0)
    *end += len;
  if (*end < 0)
    *end = 0;
  if (*start < 0)
    *start += len;
  if (*start < 0)
    *start = 0;
}

static int
string_find_internal (char *s, int len,
                      char *sub, int n, 
                      int start, int end,
                      int dir)
{
  int i = start, last = end;

  string_adjust_indices (&i, &last, len);
  
  if (dir > 0)
    {
      if (n == 0 && i <= last)
        return i;
      last -= n;
      for (; i <= last; ++i)
        if (s[i] == sub[0] && memcmp(&s[i], sub, n) == 0)
          return i;
    }
  else 
    {
      int j;
      
      if (n == 0 && i <= last)
        return last;
      for (j = last-n; j >= i; --j)
        if (s[j] == sub[0] && memcmp(&s[j], sub, n) == 0)
          return j;
    }
  
  return -1;  
}

/**
   find ޽ : find (TS)I

   StringRef  ڿ S (ι° ) ߰ߵ   index ȣ integer
   · ȯմϴ.

   @return       ڿ ι°  (StringRef)  ߰ߵ   index ȣ ȯ
*/
static int
str_find_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *sub, *str;
  int sublen, strlen;
  int result;

  if (RvParseArg (self, args, "s#", &sub, &sublen))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  result = string_find_internal (str, strlen, sub, sublen, 0, strlen, +1);
  if (result == -2)
    return -1;

  RvSetReturn (self, ret, "I", result);

  return 0;
}

/**
   find ޽ : find (TSI)I

   StringRef  ڿ S (ι° ) ߰ߵ   index ȣ integer
   · ȯմϴ.  ڿ ˻  offset  I (° )  մϴ.

   @return       ڿ ι°  (StringRef)  ߰ߵ   index ȣ ȯ
*/
static int
str_find_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *sub, *str;
  int sublen, strlen, start;
  int result;

  if (RvParseArg (self, args, "s#i", &sub, &sublen, &start))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  result = string_find_internal (str, strlen, sub, sublen, start, strlen, +1);
  if (result == -2)
    return -1;

  RvSetReturn (self, ret, "I", result);

  return 0;
}

/**
   find ޽ : find (TSII)I

   StringRef  ڿ S (ι° ) ߰ߵ   index ȣ integer
   · ȯմϴ.  ڿ ˻ ۰  offset  I (° ), I (׹°
   )  մϴ.

   @return       ڿ ι°  (StringRef)  ߰ߵ   index ȣ ȯ
*/
static int
str_find_tsii (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *sub, *str;
  int sublen, strlen, start, end;
  int result;

  if (RvParseArg (self, args, "s#ii", &sub, &sublen, &start, &end))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  result = string_find_internal (str, strlen, sub, sublen, start, end, +1);
  if (result == -2)
    return -1;

  RvSetReturn (self, ret, "I", result);

  return 0;
}

/**
   rfind ޽ : STR.rfind (TS)I

   STR  ڿ S (ι° ) ߰ߵ   index ȣ integer
   · ȯմϴ.

   @return       ڿ S (ι° )  ߰ߵ   index ȣ ȯմϴ.
*/
static int
str_rfind_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *sub, *str;
  int sublen, strlen;
  int result;

  if (RvParseArg (self, args, "s#", &sub, &sublen))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  result = string_find_internal (str, strlen, sub, sublen, 0, strlen, -1);
  if (result == -2)
    return -1;

  RvSetReturn (self, ret, "I", result);

  return 0;
}

/**
   rfind ޽ : STR.rfind (TSI)I

   STR  ڿ S (ι° ) ߰ߵ   index ȣ integer
   · ȯմϴ.  ڿ  offset  I (° )  մϴ.

   @return       ڿ S (ι° )  ߰ߵ   index ȣ ȯմϴ.
*/
static int
str_rfind_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *sub, *str;
  int sublen, strlen, start;
  int result;

  if (RvParseArg (self, args, "s#i", &sub, &sublen, &start))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  result = string_find_internal (str, strlen, sub, sublen, start, strlen, -1);
  if (result == -2)
    return -1;

  RvSetReturn (self, ret, "I", result);

  return 0;
}

/**
   rfind ޽ : STR.rfind (TSII)I

   STR  ڿ S (ι° ) ߰ߵ   index ȣ integer
   · ȯմϴ.  ڿ ۰  offset  I (° ), I (׹° ) 
    մϴ.

   @return       ڿ S (ι° )  ߰ߵ   index ȣ ȯմϴ.
*/
static int
str_rfind_tsii (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *sub, *str;
  int sublen, strlen, start, end;
  int result;

  if (RvParseArg (self, args, "s#ii", &sub, &sublen, &start, &end))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  result = string_find_internal (str, strlen, sub, sublen, start, end, -1);
  if (result == -2)
    return -1;

  RvSetReturn (self, ret, "I", result);

  return 0;
}

#define LEFTSTRIP 0
#define RIGHTSTRIP 1
#define BOTHSTRIP 2

static RvObject *
do_strip (RvObject *self, char *s, int len, int striptype)
{
  int i, j;

  i = 0;
  if (striptype != RIGHTSTRIP) 
    {
      while (i < len && isspace (s[i])) 
        i++;
    }

  j = len;
  if (striptype != LEFTSTRIP) 
    {
      do 
        {
          j--;
        }
      while (j >= i && isspace (s[j]));
      j++;
    }
  
  if (i == 0 && j == len)
    return (RvObject*) self;
  else
    return RvStrNew (self, s + i, j - i);
}

static RvObject *
do_xstrip (RvObject *self,
           char *s, int len, 
           char *sep, int seplen,
           int striptype)
{
  int i, j;
  
  i = 0;
  if (striptype != RIGHTSTRIP) 
    {
      while (i < len && memchr (sep, s[i], seplen)) 
        i++;
    }
  
  j = len;
  if (striptype != LEFTSTRIP) 
    {
      do 
        {
          j--;
        }
      while (j >= i && memchr (sep, s[j], seplen));
      j++;
    }
  
  if (i == 0 && j == len)
    return (RvObject*) self;
  else
    return RvStrNew (self, s+i, j-i);
}

/**
   strip ޽ : STR.strip (T)S

   ڿ STR  ʿ whitespace   ڿ ȯմϴ.

   @return       ڿ STR  ʿ whitespace   ڿ
*/
static int
str_strip_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  int strlen;

  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  RvSetReturn (self, ret, "S", do_strip (self, str, strlen, BOTHSTRIP));

  return 0;
}

/**
   strip ޽ : STR.strip (TS)S

   ڿ STR  ʿ ι° (S)  شϴ ڵ  ڿ ȯմϴ.

   @return       ڿ STR  ʿ ι° (S)  شϴ ڵ  ڿ
*/
static int
str_strip_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *sep;
  int strlen, seplen;

  if (RvParseArg (self, args, "s#", &sep, &seplen))
    return -1;

  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  RvSetReturn (self, ret, "S", do_xstrip (self, str, strlen, sep, seplen, BOTHSTRIP));

  return 0;
}

/**
   lstrip ޽ : STR.lstrip (T)S

   ڿ STR  ʿ whitespace   ڿ ȯմϴ.

   @return       ڿ STR  ʿ whitespace   ڿ
*/
static int
str_lstrip_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  int strlen;

  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  RvSetReturn (self, ret, "S", do_strip (self, str, strlen, LEFTSTRIP));

  return 0;
}

/**
   lstrip ޽ : STR.lstrip (TS)S

   ڿ STR  ʿ ι° (S)  شϴ ڵ  ڿ ȯմϴ.

   @return       ڿ STR  ʿ ι° (S)  شϴ ڵ  ڿ
*/
static int
str_lstrip_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *sep;
  int strlen, seplen;

  if (RvParseArg (self, args, "s#", &sep, &seplen))
    return -1;

  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  RvSetReturn (self, ret, "S", do_xstrip (self, str, strlen, sep, seplen, LEFTSTRIP));

  return 0;
}

/**
   rstrip ޽ : STR.rstrip (T)S

   ڿ STR  ʿ whitespace   ڿ ȯմϴ.

   @return       ڿ STR  ʿ whitespace   ڿ
*/
static int
str_rstrip_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  int strlen;

  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  RvSetReturn (self, ret, "S", do_strip (self, str, strlen, RIGHTSTRIP));

  return 0;
}

/**
   rstrip ޽ : STR.rstrip (TS)S

   ڿ STR  ʿ ι° (S)  شϴ ڵ  ڿ ȯմϴ.

   @return       ڿ STR  ʿ ι° (S)  شϴ ڵ  ڿ
*/
static int
str_rstrip_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *sep;
  int strlen, seplen;

  if (RvParseArg (self, args, "s#", &sep, &seplen))
    return -1;

  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  RvSetReturn (self, ret, "S", do_xstrip (self, str, strlen, sep, seplen, RIGHTSTRIP));

  return 0;
}

/**
   lower ޽ : STR.lower (T)S

   ڿ ü SELF  ڿ ҹڷ ȯϿ ׿   ȯմϴ.

   @return      ҹڷ ȯ ڿ ü
 */
static int
str_lower_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *s_new;
  int i, n;
  RvObject *new;

  if (RvStrGetInfo (self, &s, &n))
    return -1;

  new = RvStrNew (self, s, n);
  if (!new)
    return -1;
  s_new = RvStrGetPointer (new);
  for (i = 0; i < n; i++)
    {
      int c = *s++;
      
      if (isupper (c)) 
        *s_new = tolower (c);
      else
        *s_new = c;
      s_new++;
    }

  RvSetReturn (self, ret, "S", new);

  return 0;
}

/**
   upper ޽ : STR.upper (T)S

   ڿ ü SELF  ڿ 빮ڷ ȯϿ ׿   ȯմϴ.

   @return      빮ڷ ȯ ڿ ü
 */
static int
str_upper_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *s_new;
  int i, n;
  RvObject *new;

  if (RvStrGetInfo (self, &s, &n))
    return -1;

  new = RvStrNew (self, s, n);
  if (!new)
    return -1;
  s_new = RvStrGetPointer (new);
  for (i = 0; i < n; i++)
    {
      int c = *s++;
      
      if (islower (c)) 
        *s_new = toupper (c);
      else
        *s_new = c;
      s_new++;
    }

  RvSetReturn (self, ret, "S", new);

  return 0;
}

/**
   title ޽ : STR.title (T)S

   ڿ ü SELF  titlecased version ( , 빮ڷ ϴ) 
    ȯմϴ.   ڵ ҹڷ ˴ϴ.

   @return      Titlecased version  ȯ ڿ ü
 */
static int
str_title_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *s_new;
  int i, n, previous_is_cased = 0;
  RvObject *new;

  if (RvStrGetInfo (self, &s, &n))
    return -1;

  new = RvStrNew (self, s, n);
  if (!new)
    return -1;
  s_new = RvStrGetPointer (new);

  for (i = 0; i < n; i++) 
    {
      int c = *s++;
      if (islower (c)) 
        {
          if (!previous_is_cased)
            c = toupper (c);
          previous_is_cased = 1;
        }
      else if (isupper (c)) 
        {
          if (previous_is_cased)
            c = tolower (c);
          previous_is_cased = 1;
        } else
        previous_is_cased = 0;
      *s_new++ = c;
    }

  RvSetReturn (self, ret, "S", new);

  return 0;
}

/**
   capitalize ޽ : STR.capitalize (T)S
   
   Return a copy of the string S with only its first character
   capitalized.
*/
static int
str_capitalize_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *s_new;
  int i, n;
  RvObject *new;

  if (RvStrGetInfo (self, &s, &n))
    return -1;

  new = RvStrNew (self, s, n);
  if (!new)
    return -1;
  s_new = RvStrGetPointer (new);

  if (0 < n) 
    {
      int c = *s++;
      if (islower(c))
        *s_new = toupper (c);
      else
        *s_new = c;
      s_new++;
    }
  for (i = 1; i < n; i++) 
    {
      int c = *s++;
      if (isupper (c))
        *s_new = tolower (c);
      else
        *s_new = c;
      s_new++;
    }
  
  RvSetReturn (self, ret, "S", new);

  return 0;
}

/**
   Return the number of occurrences of substring sub in string
   S[start:end].  Optional arguments start and end are
   interpreted as in slice notation.
*/
static int
str_count_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *sub;
  int m, r, len, n, i = 0, last = INT_MAX;

  if (RvParseArg (self, args, "s#", &sub, &n))
    return -1;

  if (RvStrGetInfo (self, &s, &len))
    return -1;

  string_adjust_indices (&i, &last, len);

  m = last + 1 - n;
  if (n == 0)
    {
      RvSetReturn (self, ret, "I", m - i);
      return 0;
    }

  r = 0;
  while (i < m) 
    {
      if (!memcmp (s+i, sub, n)) 
        {
          r++;
          i += n;
        }
      else
        i++;
    }
  
  RvSetReturn (self, ret, "I", r);
  
  return 0;
}

/**
   Return the number of occurrences of substring sub in string
   S[start:end].  Optional arguments start and end are
   interpreted as in slice notation.
*/
static int
str_count_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *sub;
  int m, r, len, n, i = 0, last = INT_MAX;

  if (RvParseArg (self, args, "s#i", &sub, &n, &i))
    return -1;

  if (RvStrGetInfo (self, &s, &len))
    return -1;

  string_adjust_indices (&i, &last, len);

  m = last + 1 - n;
  if (n == 0)
    {
      RvSetReturn (self, ret, "I", m - i);
      return 0;
    }

  r = 0;
  while (i < m) 
    {
      if (!memcmp (s+i, sub, n)) 
        {
          r++;
          i += n;
        }
      else
        i++;
    }
  
  RvSetReturn (self, ret, "I", r);
  
  return 0;
}

/**
   Return the number of occurrences of substring sub in string
   S[start:end].  Optional arguments start and end are
   interpreted as in slice notation.
*/
static int
str_count_tsii (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *sub;
  int m, r, len, n, i = 0, last = INT_MAX;

  if (RvParseArg (self, args, "s#ii", &sub, &n, &i, &last))
    return -1;

  if (RvStrGetInfo (self, &s, &len))
    return -1;

  string_adjust_indices (&i, &last, len);

  m = last + 1 - n;
  if (n == 0)
    {
      RvSetReturn (self, ret, "I", m - i);
      return 0;
    }

  r = 0;
  while (i < m) 
    {
      if (!memcmp (s+i, sub, n)) 
        {
          r++;
          i += n;
        }
      else
        i++;
    }
  
  RvSetReturn (self, ret, "I", r);
  
  return 0;
}

/**
   Return a copy of the string S with uppercase characters
   converted to lowercase and vice versa.
*/
static int
str_swapcase_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *s_new;
  int i, n;
  RvObject *new;

  if (RvStrGetInfo (self, &s, &n))
    return -1;

  new = RvStrNew (self, s, n);
  if (!new)
    return -1;
  s_new = RvStrGetPointer (new);

  for (i = 0; i < n; i++) 
    {
      int c = *s++;
      if (islower (c)) 
        *s_new = toupper (c);
      else if (isupper (c)) 
        *s_new = tolower (c);
      else
        *s_new = c;
      s_new++;
    }

  RvSetReturn (self, ret, "S", new);

  return 0;
}

/* What follows is used for implementing replace().  Perry Stoll. */

/*
  mymemfind

  strstr replacement for arbitrary blocks of memory.

  Locates the first occurrence in the memory pointed to by MEM of the
  contents of memory pointed to by PAT.  Returns the index into MEM if
  found, or -1 if not found.  If len of PAT is greater than length of
  MEM, the function returns -1.
*/
static int
mymemfind(const char *mem, int len, const char *pat, int pat_len)
{
  register int ii;
  
  /* pattern can not occur in the last pat_len-1 chars */
  len -= pat_len;
  
  for (ii = 0; ii <= len; ii++) 
    {
      if (mem[ii] == pat[0] && memcmp(&mem[ii], pat, pat_len) == 0) 
        {
          return ii;
        }
    }
  return -1;
}

/*
  mymemcnt

   Return the number of distinct times PAT is found in MEM.
   meaning mem=1111 and pat==11 returns 2.
           mem=11111 and pat==11 also return 2.
 */
static int
mymemcnt(const char *mem, int len, const char *pat, int pat_len)
{
  register int offset = 0;
  int nfound = 0;
  
  while (len >= 0) 
    {
      offset = mymemfind(mem, len, pat, pat_len);
      if (offset == -1)
        break;
      mem += offset + pat_len;
      len -= offset + pat_len;
      nfound++;
    }
  return nfound;
}

/*
   mymemreplace

   Return a string in which all occurrences of PAT in memory STR are
   replaced with SUB.

   If length of PAT is less than length of STR or there are no occurrences
   of PAT in STR, then the original string is returned. Otherwise, a new
   string is allocated here and returned.

   on return, out_len is:
       the length of output string, or
       -1 if the input string is returned, or
       unchanged if an error occurs (no memory).

   return value is:
       the new string allocated locally, or
       NULL if an error occurred.
*/
static char *
mymemreplace(RvObject *self,
             const char *str, int len,		/* input string */
             const char *pat, int pat_len,	/* pattern string to find */
             const char *sub, int sub_len,	/* substitution string */
             int count,				/* number of replacements */
	     int *out_len)
{
  char *out_s;
  char *new_s;
  int nfound, offset, new_len;
  
  if (len == 0 || (pat_len == 0 && sub_len == 0) || pat_len > len)
    goto return_same;
  
  /* find length of output string */
  nfound = (pat_len > 0) ? mymemcnt(str, len, pat, pat_len) : len + 1;
  if (count < 0)
    count = INT_MAX;
  else if (nfound > count)
    nfound = count;
  if (nfound == 0)
    goto return_same;
  
  new_len = len + nfound*(sub_len - pat_len);
  if (new_len == 0) 
    {
      /* Have to allocate something for the caller to free(). */
      out_s = (char *)RvMemMalloc (self, 1);
      if (out_s == NULL)
        return NULL;
      out_s[0] = '\0';
    }
  else 
    {
      assert(new_len > 0);
      new_s = (char *) RvMemMalloc (self, new_len);
      if (new_s == NULL)
        return NULL;
      out_s = new_s;
      
      if (pat_len > 0) 
        {
          for (; nfound > 0; --nfound) 
            {
              /* find index of next instance of pattern */
              offset = mymemfind(str, len, pat, pat_len);
              if (offset == -1)
                break;
              
              /* copy non matching part of input string */
              memcpy(new_s, str, offset);
              str += offset + pat_len;
              len -= offset + pat_len;
              
              /* copy substitute into the output string */
              new_s += offset;
              memcpy(new_s, sub, sub_len);
              new_s += sub_len;
            }
          /* copy any remaining values into output string */
          if (len > 0)
            memcpy (new_s, str, len);
        }
      else 
        {
          for (;;++str, --len) 
            {
              memcpy(new_s, sub, sub_len);
              new_s += sub_len;
              if (--nfound <= 0) 
                {
                  memcpy(new_s, str, len);
                  break;
                }
              *new_s++ = *str;
            }
        }
    }
  *out_len = new_len;
  return out_s;
  
 return_same:
  *out_len = -1;

  return (char *)str; /* cast away const */
}

/**
   Return a copy of string S with all occurrences of substring
   old replaced by new.  If the optional argument count is
   given, only the first count occurrences are replaced.
*/
static int
str_replace_tss (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *sub, *repl, *new_s;
  int len, sub_len, repl_len;
  int count = -1, out_len;
  RvObject *new;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (RvParseArg (self, args, "s#s#", &sub, &sub_len, &repl, &repl_len))
    return -1;

  new_s = mymemreplace (self, str, len, sub, sub_len, repl, repl_len, count, &out_len);
  if (!new_s)
    {
      RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "Out of memory");
      return -1;
    }

  if (out_len == -1)
    new = RvStrNew (self, str, len);
  else
    new = RvStrNew (self, new_s, out_len);

  if (!new)
    return -1;

  RvSetReturn (self, ret, "S", new);

  return 0;
}

/**
   Return a copy of string S with all occurrences of substring
   old replaced by new.  If the optional argument count is
   given, only the first count occurrences are replaced.
*/
static int
str_replace_tssi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *sub, *repl, *new_s;
  int len, sub_len, repl_len;
  int count = -1, out_len;
  RvObject *new;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (RvParseArg (self, args, "s#s#i", &sub, &sub_len, &repl, &repl_len, &count))
    return -1;

  new_s = mymemreplace (self, str, len, sub, sub_len, repl, repl_len, count, &out_len);
  if (!new_s)
    {
      RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "Out of memory");
      return -1;
    }

  if (out_len == -1)
    new = RvStrNew (self, str, len);
  else
    new = RvStrNew (self, new_s, out_len);

  if (!new)
    return -1;

  RvSetReturn (self, ret, "S", new);

  return 0;
}

/**
   Return True if S starts with the specified prefix, False otherwise.
   With optional start, test S beginning at that position.
   With optional end, stop comparing S at that position.
*/
static int
str_startswitch_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *prefix;
  int len, plen;
  int start = 0;
  int end = INT_MAX;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (RvParseArg (self, args, "s#", &prefix, &plen))
    return -1;

  string_adjust_indices (&start, &end, len);
  
  if (start+plen > len)
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }

  if (end-start >= plen)
    {
      RvSetReturn (self, ret, "B", !memcmp(str+start, prefix, plen));

      return 0;
    }
  else
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }
}

/**
   Return True if S starts with the specified prefix, False otherwise.
   With optional start, test S beginning at that position.
   With optional end, stop comparing S at that position.
*/
static int
str_startswitch_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *prefix;
  int len, plen;
  int start = 0;
  int end = INT_MAX;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (RvParseArg (self, args, "s#i", &prefix, &plen, &start))
    return -1;

  string_adjust_indices (&start, &end, len);
  
  if (start+plen > len)
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }

  if (end-start >= plen)
    {
      RvSetReturn (self, ret, "B", !memcmp(str+start, prefix, plen));

      return 0;
    }
  else
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }
}

/**
   Return True if S starts with the specified prefix, False otherwise.
   With optional start, test S beginning at that position.
   With optional end, stop comparing S at that position.
*/
static int
str_startswitch_tsii (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *prefix;
  int len, plen;
  int start = 0;
  int end = INT_MAX;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (RvParseArg (self, args, "s#ii", &prefix, &plen, &start, &end))
    return -1;

  string_adjust_indices (&start, &end, len);
  
  if (start+plen > len)
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }

  if (end-start >= plen)
    {
      RvSetReturn (self, ret, "B", !memcmp(str+start, prefix, plen));

      return 0;
    }
  else
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }
}

static int
str_endswitch_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *suffix;
  int len, slen;
  int start = 0;
  int end = INT_MAX;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (RvParseArg (self, args, "s#", &suffix, &slen))
    return -1;

  string_adjust_indices (&start, &end, len);
  
  if (end-start < slen || start > len)
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }

  if (end-slen > start)
    start = end - slen;

  if (end-start >= slen)
    {
      RvSetReturn (self, ret, "B", !memcmp (str+start, suffix, slen));

      return 0;
    }
  else
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }
}

static int
str_endswitch_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *suffix;
  int len, slen;
  int start = 0;
  int end = INT_MAX;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (RvParseArg (self, args, "s#i", &suffix, &slen, &start))
    return -1;

  string_adjust_indices (&start, &end, len);
  
  if (end-start < slen || start > len)
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }

  if (end-slen > start)
    start = end - slen;

  if (end-start >= slen)
    {
      RvSetReturn (self, ret, "B", !memcmp(str+start, suffix, slen));

      return 0;
    }
  else
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }
}

static int
str_endswitch_tsii (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str, *suffix;
  int len, slen;
  int start = 0;
  int end = INT_MAX;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (RvParseArg (self, args, "s#ii", &suffix, &slen, &start, &end))
    return -1;

  string_adjust_indices (&start, &end, len);
  
  if (end-start < slen || start > len)
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }

  if (end-slen > start)
    start = end - slen;

  if (end-start >= slen)
    {
      RvSetReturn (self, ret, "B", !memcmp(str+start, suffix, slen));

      return 0;
    }
  else
    {
      RvSetReturn (self, ret, "B", 0);

      return 0;
    }
}

/**
   Return a copy of S where all tab characters are expanded using spaces.
   If tabsize is not given, a tab size of 8 characters is assumed.
*/
static int
str_expandtabs_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  const char *e, *p;
  char *q;
  int i, j, len;
  int tabsize = 8;
  RvObject *u;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  /* First pass: determine size of output string */
  i = j = 0;
  e = (const char *) (str + len);
  for (p = str; p < e; p++)
    if (*p == '\t') 
      {
        if (tabsize > 0)
          j += tabsize - (j % tabsize);
      }
    else 
      {
        j++;
        if (*p == '\n' || *p == '\r') 
          {
            i += j;
            j = 0;
          }
      }
  
  /* Second pass: create output string and fill it */
  u = RvStrNew (self, NULL, i + j);
  if (!u)
    return -1;

  j = 0;
  q = RvStrGetPointer (u);

  for (p = str; p < e; p++)
    if (*p == '\t') 
      {
        if (tabsize > 0) 
          {
            i = tabsize - (j % tabsize);
            j += i;
            while (i--)
              *q++ = ' ';
          }
      }
    else 
      {
        j++;
        *q++ = *p;
        if (*p == '\n' || *p == '\r')
          j = 0;
      }

  RvSetReturn (self, ret, "S", u);
  
  return 0;
}

/**
   Return a copy of S where all tab characters are expanded using spaces.
   If tabsize is not given, a tab size of 8 characters is assumed.
*/
static int
str_expandtabs_ti (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  const char *e, *p;
  char *q;
  int i, j, len;
  int tabsize = 8;
  RvObject *u;

  if (RvParseArg (self, args, "i", &tabsize))
    return -1;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  /* First pass: determine size of output string */
  i = j = 0;
  e = (const char *) (str + len);
  for (p = str; p < e; p++)
    if (*p == '\t') 
      {
        if (tabsize > 0)
          j += tabsize - (j % tabsize);
      }
    else 
      {
        j++;
        if (*p == '\n' || *p == '\r') 
          {
            i += j;
            j = 0;
          }
      }
  
  /* Second pass: create output string and fill it */
  u = RvStrNew (self, NULL, i + j);
  if (!u)
    return -1;

  j = 0;
  q = RvStrGetPointer (u);

  for (p = str; p < e; p++)
    if (*p == '\t') 
      {
        if (tabsize > 0) 
          {
            i = tabsize - (j % tabsize);
            j += i;
            while (i--)
              *q++ = ' ';
          }
      }
    else 
      {
        j++;
        *q++ = *p;
        if (*p == '\n' || *p == '\r')
          j = 0;
      }

  RvSetReturn (self, ret, "S", u);
  
  return 0;
}

static RvObject *
pad (RvObject *self, char *str, int len, int left, int right, char fill)
{
  RvObject *u;
  char *uptr;

  if (left < 0)
    left = 0;
  if (right < 0)
    right = 0;
  
  if (left == 0 && right == 0)
    return (RvObject *) self;

  u = RvStrNew (self, NULL, left + len + right);
  if (u) 
    {
      uptr = RvStrGetPointer (u);
      if (left)
        memset (uptr, fill, left);
      memcpy (uptr + left, str, len);
      if (right)
        memset (uptr + left + len, fill, right);
    }
  
  return u;
}

/**
   Return S left justified in a string of length width. Padding is
   done using the specified fill character (default is a space).
*/
static int
str_ljust_ti (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int width, len;
  char *str, fillchar = ' ';

  if (RvParseArg (self, args, "i", &width))
    return -1;

  if (RvStrGetInfo (self, &str, &len))
    return -1;
  
  if (len >= width)
    {
      RvSetReturn (self, ret, "S", self);
      return 0;
    }
  
  RvSetReturn (self, ret, "S", pad (self, str, len, 0, width - len, fillchar));
  return 0;
}

/**
   Return S left justified in a string of length width. Padding is
   done using the specified fill character (default is a space).
*/
static int
str_ljust_tic (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int width, len;
  char *str, fillchar = ' ';

  if (RvParseArg (self, args, "ic", &width, &fillchar))
    return -1;

  if (RvStrGetInfo (self, &str, &len))
    return -1;
  
  if (len >= width)
    {
      RvSetReturn (self, ret, "S", self);
      return 0;
    }
  
  RvSetReturn (self, ret, "S", pad (self, str, len, 0, width - len, fillchar));
  return 0;
}

/**
   Return S right justified in a string of length width. Padding is
   done using the specified fill character (default is a space)
*/
static int
str_rjust_ti (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int width, len;
  char *str, fillchar = ' ';

  if (RvParseArg (self, args, "i", &width))
    return -1;

  if (RvStrGetInfo (self, &str, &len))
    return -1;
  
  if (len >= width)
    {
      RvSetReturn (self, ret, "S", self);
      return 0;
    }
  
  RvSetReturn (self, ret, "S", pad (self, str, len, width - len, 0, fillchar));

  return 0;
}

/**
   Return S right justified in a string of length width. Padding is
   done using the specified fill character (default is a space)
*/
static int
str_rjust_tic (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int width, len;
  char *str, fillchar = ' ';

  if (RvParseArg (self, args, "ic", &width, &fillchar))
    return -1;

  if (RvStrGetInfo (self, &str, &len))
    return -1;
  
  if (len >= width)
    {
      RvSetReturn (self, ret, "S", self);
      return 0;
    }
  
  RvSetReturn (self, ret, "S", pad (self, str, len, width - len, 0, fillchar));

  return 0;
}

static int
str_center_ti (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int marg, left;
  int width, len;
  char *str, fillchar = ' ';

  if (RvParseArg (self, args, "i", &width))
    return -1;

  if (RvStrGetInfo (self, &str, &len))
    return -1;
  
  if (len >= width)
    {
      RvSetReturn (self, ret, "S", self);
      return 0;
    }

  marg = width - len;
  left = marg / 2 + (marg & width & 1);

  RvSetReturn (self, ret, "S", pad (self, str, len, left, marg - left, fillchar));

  return 0;
}

static int
str_center_tic (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int marg, left;
  int width, len;
  char *str, fillchar = ' ';

  if (RvParseArg (self, args, "ic", &width, &fillchar))
    return -1;

  if (RvStrGetInfo (self, &str, &len))
    return -1;
  
  if (len >= width)
    {
      RvSetReturn (self, ret, "S", self);
      return 0;
    }

  marg = width - len;
  left = marg / 2 + (marg & width & 1);

  RvSetReturn (self, ret, "S", pad (self, str, len, left, marg - left, fillchar));

  return 0;
}

static int
str_zfill_ti (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int fill, width, len;
  char *p, *str;
  RvObject *s;

  if (RvParseArg (self, args, "i", &width))
    return -1;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  if (len >= width)
    {
      RvSetReturn (self, ret, "S", self);
      return 0;
    }

  fill = width - len;

  s = pad (self, str, len, fill, 0, '0');
  if (s == NULL)
    return -1;

  p = RvStrGetPointer (s);
  if (p[fill] == '+' || p[fill] == '-') 
    {
      /* move sign to beginning of string */
      p[0] = p[fill];
      p[fill] = '0';
    }

  RvSetReturn (self, ret, "S", s);

  return 0;
}

static int
str_isspace_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  unsigned char *e, *p;
  int len;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  p = (unsigned char *) str;

  if (len == 1 && isspace (*p))
    {
      RvSetReturn (self, ret, "B", 1);
      return 0;
    }

  if (len == 0)
    {
      RvSetReturn (self, ret, "B", 0);
      return 0;
    }

  e = p + len;
  for (; p < e; p++) 
    {
      if (!isspace (*p))
        {
          RvSetReturn (self, ret, "B", 0);
          return 0;
        }
    }

  RvSetReturn (self, ret, "B", 1);
  return 0;
}

static int
str_isalpha_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  unsigned char *e, *p;
  int len;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  p = (unsigned char *) str;

  if (len == 1 && isalpha (*p))
    {
      RvSetReturn (self, ret, "B", 1);
      return 0;
    }

  if (len == 0)
    {
      RvSetReturn (self, ret, "B", 0);
      return 0;
    }

  e = p + len;
  for (; p < e; p++) 
    {
      if (!isalpha (*p))
        {
          RvSetReturn (self, ret, "B", 0);
          return 0;
        }
    }

  RvSetReturn (self, ret, "B", 1);
  return 0;
}

static int
str_isalnum_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  unsigned char *e, *p;
  int len;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  p = (unsigned char *) str;

  if (len == 1 && isalnum (*p))
    {
      RvSetReturn (self, ret, "B", 1);
      return 0;
    }

  if (len == 0)
    {
      RvSetReturn (self, ret, "B", 0);
      return 0;
    }

  e = p + len;
  for (; p < e; p++) 
    {
      if (!isalnum (*p))
        {
          RvSetReturn (self, ret, "B", 0);
          return 0;
        }
    }

  RvSetReturn (self, ret, "B", 1);
  return 0;
}

static int
str_isdigit_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  unsigned char *e, *p;
  int len;

  if (RvStrGetInfo (self, &str, &len))
    return -1;

  p = (unsigned char *) str;

  if (len == 1 && isdigit (*p))
    {
      RvSetReturn (self, ret, "B", 1);
      return 0;
    }

  if (len == 0)
    {
      RvSetReturn (self, ret, "B", 0);
      return 0;
    }

  e = p + len;
  for (; p < e; p++) 
    {
      if (!isdigit (*p))
        {
          RvSetReturn (self, ret, "B", 0);
          return 0;
        }
    }

  RvSetReturn (self, ret, "B", 1);
  return 0;
}

static int
str_islower_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  unsigned char *e, *p;
  int len, cased;
    
  if (RvStrGetInfo (self, &str, &len))
    return -1;
  
  p = (unsigned char *) str;

  if (len == 1)
    {
      RvSetReturn (self, ret, "B", islower (*p) != 0);
      return 0;
    }

  if (len == 0)
    {
      RvSetReturn (self, ret, "B", 0);
      return 0;
    }

  e = p + len;
  cased = 0;

  for (; p < e; p++) 
    {
      if (isupper(*p))
        {
          RvSetReturn (self, ret, "B", 0);
          return 0;
        }
      else if (!cased && islower (*p))
        cased = 1;
    }

  RvSetReturn (self, ret, "B", cased);
  return 0;
}

static int
str_isupper_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  unsigned char *e, *p;
  int len, cased;
    
  if (RvStrGetInfo (self, (char **) &str, &len))
    return -1;

  p = (unsigned char *) str;

  if (len == 1)
    {
      RvSetReturn (self, ret, "B", islower (*p) != 0);
      return 0;
    }

  if (len == 0)
    {
      RvSetReturn (self, ret, "B", 0);
      return 0;
    }

  e = p + len;
  cased = 0;

  for (; p < e; p++) 
    {
      if (islower (*p))
        {
          RvSetReturn (self, ret, "B", 0);
          return 0;
        }
      else if (!cased && isupper (*p))
        cased = 1;
    }

  RvSetReturn (self, ret, "B", cased);

  return 0;
}

static int
str_istitle_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  unsigned char *e, *p;
  int len, cased, previous_is_cased;
    
  if (RvStrGetInfo (self, (char **) &str, &len))
    return -1;

  p = (unsigned char *) str;

  if (len == 1)
    {
      RvSetReturn (self, ret, "B", isupper (*p) != 0);
      return 0;
    }

  if (len == 0)
    {
      RvSetReturn (self, ret, "B", 0);
      return 0;
    }

  e = p + len;
  cased = 0;
  previous_is_cased = 0;

  for (; p < e; p++) 
    {
      register const unsigned char ch = *p;
      
      if (isupper(ch)) 
        {
          if (previous_is_cased)
            {
              RvSetReturn (self, ret, "B", 0);
              return 0;
            }
          previous_is_cased = 1;
          cased = 1;
	}
      else if (islower(ch)) 
        {
          if (!previous_is_cased)
            {
              RvSetReturn (self, ret, "B", 0);
              return 0;
            }
          previous_is_cased = 1;
          cased = 1;
	}
      else
        previous_is_cased = 0;
    }

  RvSetReturn (self, ret, "B", cased);
  return 0;
}

#define SPLIT_APPEND(data, left, right)				\
  str = RvStrNew (self, (data) + (left), (right) - (left));     \
  if (!str)                                                     \
    goto onError;                                               \
  if (RvArrayPush (list, "S", str))				\
    goto onError;

static int
str_splitlines_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  register int i;
  register int j;
  int len;
  int keepends = 0;
  RvObject *list;
  RvObject *str;
  char *data;
  
  if (RvStrGetInfo (self, (char **) &data, &len))
    return -1;

  list = RvArrayNew (self, 0);
  if (!list)
    goto onError;

  for (i = j = 0; i < len; ) 
    {
      int eol;
      
      /* Find a line and append it */
      while (i < len && data[i] != '\n' && data[i] != '\r')
        i++;
      
      /* Skip the line break reading CRLF as one line break */
      eol = i;
      if (i < len) 
        {
          if (data[i] == '\r' && i + 1 < len && data[i+1] == '\n')
            i += 2;
          else
            i++;
          if (keepends)
            eol = i;
	}
      SPLIT_APPEND (data, j, eol);
      j = i;
    }
  if (j < len) 
    {
      SPLIT_APPEND(data, j, len);
    }
  
  RvSetReturn (self, ret, "[", list);
  return 0;
  
 onError:
  return -1;
}

static int
str_splitlines_ti (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  register int i;
  register int j;
  int len;
  int keepends = 0;
  RvObject *list;
  RvObject *str;
  char *data;

  if (RvParseArg (self, args, "i", &keepends))
    return -1;
  
  if (RvStrGetInfo (self, (char **) &data, &len))
    return -1;

  list = RvArrayNew (self, 0);
  if (!list)
    goto onError;

  for (i = j = 0; i < len; ) 
    {
      int eol;
      
      /* Find a line and append it */
      while (i < len && data[i] != '\n' && data[i] != '\r')
        i++;
      
      /* Skip the line break reading CRLF as one line break */
      eol = i;
      if (i < len) 
        {
          if (data[i] == '\r' && i + 1 < len && data[i+1] == '\n')
            i += 2;
          else
            i++;
          if (keepends)
            eol = i;
	}
      SPLIT_APPEND (data, j, eol);
      j = i;
    }
  if (j < len) 
    {
      SPLIT_APPEND(data, j, len);
    }

  RvSetReturn (self, ret, "[", list);
  return 0;

 onError:
  return -1;
}

#define SPLIT_INSERT(data, left, right)			 	\
  str = RvStrNew (self, (data) + (left), (right) - (left));     \
  if (str == NULL)                                              \
    goto onError;                                               \
  if (RvArrayInsert (list, 0, "S", str))                        \
    goto onError;

static RvObject *
rsplit_whitespace (RvObject *self, char *s, int len, int maxsplit)
{
  int i, j;
  RvObject *str;
  RvObject *list = RvArrayNew (self, 0);
  
  if (list == NULL)
    return NULL;

  for (i = j = len - 1; i >= 0; ) 
    {
      while (i >= 0 && isspace (s[i]))
        i--;
      j = i;
      while (i >= 0 && !isspace(s[i]))
        i--;
      if (j > i) 
        {
          if (maxsplit-- <= 0)
            break;
          SPLIT_INSERT(s, i + 1, j + 1);
          while (i >= 0 && isspace(s[i]))
            i--;
          j = i;
        }
    }
  if (j >= 0) 
    {
      SPLIT_INSERT(s, 0, j + 1);
    }
  return list;

 onError:
  return NULL;
}

static int
str_rsplit_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s;
  int len;
  int maxsplit = -1;

  if (RvStrGetInfo (self, &s, &len))
    return -1;

  if (maxsplit < 0)
    maxsplit = INT_MAX;

  RvSetReturn (self, ret, "[", rsplit_whitespace (self, s, len, maxsplit));

  return 0;
}

static RvObject *
rsplit_char (RvObject *self, char *s, int len, char ch, int maxcount)
{
  register int i, j;
  RvObject *str;
  RvObject *list = RvArrayNew (self, 0);
  
  if (list == NULL)
    return NULL;
  
  for (i = j = len - 1; i >= 0; ) 
    {
      if (s[i] == ch) 
        {
          if (maxcount-- <= 0)
            break;
          SPLIT_INSERT(s, i + 1, j + 1);
          j = i = i - 1;
        } else
        i--;
    }
  if (j >= -1) 
    {
      SPLIT_INSERT(s, 0, j + 1);
    }
  return list;
  
 onError:
  return NULL;
}

static int
str_rsplit_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *sub;
  int i, j, len, n, err;
  int maxsplit = -1;
  RvObject *list, *item;

  if (RvParseArg (self, args, "s#", &sub, &n))
    return -1;

  if (RvStrGetInfo (self, &s, &len))
    return -1;

  if (maxsplit < 0)
    maxsplit = INT_MAX;

  if (n == 0)
    {
      RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "empty separator");
      return -1;
    }
  else if (n == 1)
    {
      RvSetReturn (self, ret, "[", rsplit_char (self, s, len, sub[0], maxsplit));
      return 0;
    }

  list = RvArrayNew (self, 0);
  if (list == NULL)
    return -1;
  
  j = len;
  i = j - n;
  while (i >= 0)
    {
      if (s[i] == sub[0] && memcmp(s+i, sub, n) == 0) 
        {
          if (maxsplit-- <= 0)
            break;
          item = RvStrNew (self, s+i+n, (int)(j-i-n));
          if (item == NULL)
            goto fail;
          err = RvArrayInsert (list, 0, "S", item);
          if (err < 0)
            goto fail;
          j = i;
          i -= n;
        }
      else
        i--;
    }

  item = RvStrNew (self, s, j);
  if (item == NULL)
    goto fail;
  err = RvArrayInsert (list, 0, "S", item);
  if (err < 0)
    goto fail;

  RvSetReturn (self, ret, "[", list);
  return 0;

 fail:
  return -1;
}

static int
str_rsplit_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *s, *sub;
  int i, j, len, n, err;
  int maxsplit = -1;
  RvObject *list, *item;

  if (RvParseArg (self, args, "s#i", &sub, &n, &maxsplit))
    return -1;

  if (RvStrGetInfo (self, &s, &len))
    return -1;

  if (maxsplit < 0)
    maxsplit = INT_MAX;

  if (n == 0)
    {
      RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "empty separator");
      return -1;
    }
  else if (n == 1)
    {
      RvSetReturn (self, ret, "[", rsplit_char (self, s, len, sub[0], maxsplit));
      return 0;
    }

  list = RvArrayNew (self, 0);
  if (list == NULL)
    return -1;
  
  j = len;
  i = j - n;
  while (i >= 0) 
    {
      if (s[i] == sub[0] && memcmp(s+i, sub, n) == 0) 
        {
          if (maxsplit-- <= 0)
            break;
          item = RvStrNew (self, s+i+n, (int)(j-i-n));
          if (item == NULL)
            goto fail;
          err = RvArrayInsert (list, 0, "S", item);
          if (err < 0)
            goto fail;
          j = i;
          i -= n;
        }
      else
        i--;
    }

  item = RvStrNew (self, s, j);
  if (item == NULL)
    goto fail;
  err = RvArrayInsert (list, 0, "S", item);
  if (err < 0)
    goto fail;

  RvSetReturn (self, ret, "[", list);
  return 0;

 fail:
  return -1;
}

static int
str_join_ta (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *sep, *p;
  int i, seqlen = 0, seplen;
  size_t sz = 0;
  RvObject *seq, *res, *str;
  RvValue *item;

  if (RvStrGetInfo (self, &sep, &seplen))
    return -1;

  /* ù° ڰ ArrayRef ̹Ƿ Ʒ    ֽϴ.   ƴ ,
     NULL_OBJECT  ȯ Դϴ.  */
  seq = RvValueArrayRef (args);
  if (!seq)
    {
      RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "invalid argument type");
      return -1;
    }

  seqlen = RvArrayLength (seq);
  if (seqlen == 0)
    {
      RvSetReturn (self, ret, "S", RvStrNew (self, "", 0));
      return 0;
    }
  if (seqlen == 1)
    {
      item = RvArrayGetItem (seq, 0);
      if (RvValueIsStringRef (item))
        {
          RvSetReturn (self, ret, "S", RvValueStringRef (item));
          return 0;
        }
    }
  
  /* There are at least two things to join, or else we have a subclass
   * of the builtin types in the sequence.  
   * Do a pre-pass to figure out the total amount of space we'll
   * need (sz), see whether any argument is absurd, and defer to
   * the Unicode join if appropriate.
   */
  for (i = 0; i < seqlen; i++)
    {
      const size_t old_sz = sz;
      item = RvArrayGetItem (seq, i);
      if (!RvValueIsStringRef (item))
        {
          RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, 
                      "array item %i: expected string,"
                      " %.80s found",
                      i, RvGetTypeName (item));
          return -1;
        }
      str = RvValueStringRef (item);
      sz += RvStrSize (str);
      if (i != 0)
        sz += seplen;
      if (sz < old_sz || sz > INT_MAX) 
        {
          RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, "join() is too long for a ROVM string");
          return -1;
        }
    }
  
  /* Allocate result space. */
  res = RvStrNew (self, (char*) NULL, (int) sz);
  if (!res)
    return -1;
  
  /* Catenate everything. */
  p = RvStrGetPointer (res);
  for (i = 0; i < seqlen; ++i) 
    {
      size_t n;
      str = RvValueStringRef (RvArrayGetItem (seq, i));
      n = RvStrSize (str);
      memcpy (p, RvStrGetPointer (str), n);
      p += n;
      if (i < seqlen - 1) 
        {
          memcpy(p, sep, seplen);
          p += seplen;
        }
    }

  RvSetReturn (self, ret, "S", res);
  
  return 0;
}

static RvMethodDef method[] =
  {
    { "__init__",       "(TSI)V",       str_init_tsi },
    { "capitalize",     "(T)S",         str_capitalize_t },
    { "center",         "(TI)S",        str_center_ti },
    { "center",         "(TIC)S",       str_center_tic },
    { "count",          "(TS)I",        str_count_ts },
    { "count",          "(TSI)I",       str_count_tsi },
    { "count",          "(TSII)I",      str_count_tsii },
    { "endswith",       "(TS)B",        str_endswitch_ts },
    { "endswith",       "(TSI)B",       str_endswitch_tsi },
    { "endswith",       "(TSII)B",      str_endswitch_tsii },
    { "expandtabs",     "(T)S",         str_expandtabs_t },
    { "expandtabs",     "(TI)S",        str_expandtabs_ti },
    { "find",           "(TS)I",        str_find_ts },
    { "find",           "(TSI)I",       str_find_tsi },
    { "find",           "(TSII)I",      str_find_tsii },
    { "isspace",        "(T)B",         str_isspace_t },
    { "isalpha",        "(T)B",         str_isalpha_t },
    { "isalnum",        "(T)B",         str_isalnum_t },
    { "isdigit",        "(T)B",         str_isdigit_t },
    { "islower",        "(T)B",         str_islower_t },
    { "isupper",        "(T)B",         str_isupper_t },
    { "istitle",        "(T)B",         str_istitle_t },
    { "join",           "(T[)S",        str_join_ta },
    { "ljust",          "(TI)S",        str_ljust_ti },
    { "ljust",          "(TIC)S",       str_ljust_tic },
    { "lower",          "(T)S",         str_lower_t },
    { "lstrip",         "(T)S",         str_lstrip_t },
    { "lstrip",         "(TS)S",        str_lstrip_ts },
    { "replace",        "(TSS)S",       str_replace_tss },
    { "replace",        "(TSSI)S",      str_replace_tssi },
    { "rfind",          "(TS)I",        str_rfind_ts },
    { "rfind",          "(TSI)I",       str_rfind_tsi },
    { "rfind",          "(TSII)I",      str_rfind_tsii },
    { "rjust",          "(TI)S",        str_rjust_ti },
    { "rjust",          "(TIC)S",       str_rjust_tic },
    { "rsplit",         "(T)[",         str_rsplit_t },
    { "rsplit",         "(TS)[",        str_rsplit_ts },
    { "rsplit",         "(TSI)[",       str_rsplit_tsi },
    { "rstrip",         "(T)S",         str_rstrip_t },
    { "rstrip",         "(TS)S",        str_rstrip_ts },
    { "split",          "(T)[",         str_split_t },
    { "split",          "(TS)[",        str_split_ts },
    { "split",          "(TSI)[",       str_split_tsi },
    { "splitlines",     "(T)[",         str_splitlines_t },
    { "splitlines",     "(TI)[",        str_splitlines_ti },
    { "startswith",     "(TS)B",        str_startswitch_ts },
    { "startswith",     "(TSI)B",       str_startswitch_tsi },
    { "startswith",     "(TSII)B",      str_startswitch_tsii },
    { "strip",          "(T)S",         str_strip_t },
    { "strip",          "(TS)S",        str_strip_ts },
    { "swapcase",       "(T)S",         str_swapcase_t },
    { "title",          "(T)S",         str_title_t },
    { "upper",          "(T)S",         str_upper_t },
    { "zfill",          "(TI)S",        str_zfill_ti },
    { NULL, },
  };

/** entry point.  */
int
init_str (RvClass *cls)
{
  if (RvDefineFields (cls, field))
    return -1;

  if (RvDefineMethods (cls, method))
    return -1;

  return 0;
}
