#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <limits.h>
#include <assert.h>

void *
xmalloc (size_t size)
{
  return malloc (size);
}

void
xfree (void *ptr)
{
  free (ptr);
}

void *
xrealloc (void *ptr, size_t size)
{
  return realloc (ptr, size);
}

unsigned long
scan_oct (start, len, retlen)
    const char *start;
    int len;
    int *retlen;
{
  register const char *s = start;
  register unsigned long retval = 0;
  
  while (len-- && *s >= '0' && *s <= '7') 
    {
      retval <<= 3;
      retval |= *s++ - '0';
    }
  *retlen = s - start;
  return retval;
}

unsigned long
scan_hex(start, len, retlen)
    const char *start;
    int len;
    int *retlen;
{
  static char hexdigit[] = "0123456789abcdef0123456789ABCDEF";
  register const char *s = start;
  register unsigned long retval = 0;
  char *tmp;
  
  while (len-- && *s && (tmp = strchr(hexdigit, *s))) 
    {
      retval <<= 4;
      retval |= (tmp - hexdigit) & 15;
      s++;
    }
  *retlen = s - start;
  return retval;
}
