#include <stdio.h>
#include <stdlib.h>

#include "el.h"
#define ROVM
#include "regex.h"

#include "regexmodule.h"

static RvObject *
newregexobject (self, pattern, givenpat, groupindex)
     RvObject *self, *pattern, *givenpat, *groupindex;
{
  RvObject *re;
  char *pat;
  int size;

  if (RvStrGetInfo (pattern, &pat, &size))
    return NULL_OBJECT;

  re = RvObjectNew (self, 0, "localhost", 0, "/test/regex.regex");
  if (re)
    {
      char *error;
      rovmregex_t *rt;

      rt = (rovmregex_t *) calloc (1, sizeof (regex_t));
      if (!rt)
        return NULL_OBJECT;
      rt->re_patbuf = (struct re_pattern_buffer *) calloc (1, sizeof (struct re_pattern_buffer));
      rt->re_fastmap = (char *) calloc (1, sizeof (char) * 256);
      RvSetUserData (re, UD_RE, (void *) rt);

      rt->re_patbuf->buffer = NULL;
      rt->re_patbuf->allocated = 0;
      rt->re_patbuf->fastmap = (unsigned char *)rt->re_fastmap;

      RvSetField (re, "lastok", "S", NULL);
      RvSetField (re, "groupindex", "T", groupindex);
      RvSetField (re, "realpat", "S", pattern);
      RvSetField (re, "givenpat", "S", givenpat);
      error = rovm_re_compile_pattern ((unsigned char *) pat, size, rt->re_patbuf);
      if (error != NULL)
        {
          RvLogError (self, ERRLOG_ERR, ERRLOG_MARK, error);
          return NULL_OBJECT;
        }
    }

  return (RvObject *)re;
}

int
regex_compile_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  RvObject *pat = NULL;
  RvObject *ro;

  if (RvParseArg (self, args, "S", &pat))
    return -1;

  ro = newregexobject (self, pat, pat, NULL);
  if (!ro)
    return -1;

  RvSetReturn (self, ret, "T", ro);

  return 0;
}

static RvMethodDef method[] =
  {
    { "compile",        "(TS)T",        regex_compile_ts },
    { NULL, },
  };

/** entry point.  */
int
init_regex (RvClass *cls)
{
  if (RvDefineMethods (cls, method))
    return -1;

  return 0;
}
